void SetTemplateSource(char** Vals, void* TargetStruct, void* TempStruct, int Number, bool header)
{
	static int valcount, namepos, crscriptpos, mixedpos, forcetypepos, forbittypepos, scriptpos, attrpos;
	static int newtypepos;
	char* pAttrPos;
	int i;

	if (header)
	{
		namepos = GetValNumber(Vals, "Name", Number);
		crscriptpos = GetValNumber(Vals, "CRScript", Number);
		mixedpos = GetValNumber(Vals, "Mixed", Number);
		forcetypepos = GetValNumber(Vals, "ForceType", Number);
		forbittypepos = GetValNumber(Vals, "ForbitType", Number);
		scriptpos = GetValNumber(Vals, "Script", Number);
		attrpos = GetValNumber(Vals, "AttrMod", Number);
		newtypepos = GetValNumber(Vals, "NewType", Number);

		valcount = Number;
		return;
	}

	if (Number != valcount)
	{
		printf("Invalid Number of Arguments in TemplateSource Database (%s)\n", Vals[0]);
		quitprog();
	}

	((clsTemplateSource*) TargetStruct)->Name = Vals[namepos];
	((clsTemplateSource*) TargetStruct)->Mixed = atoi(Vals[mixedpos]);

	((clsTemplateSource*) TargetStruct)->NewType = Vals[newtypepos];

	((clsTemplateSource*) TargetStruct)->ForceType = Vals[forcetypepos];
	((clsTemplateSource*) TargetStruct)->ForbitType = Vals[forbittypepos];
	str_replace(';', 0, ((clsTemplateSource*) TargetStruct)->ForceType.buffer);
	str_replace(';', 0, ((clsTemplateSource*) TargetStruct)->ForbitType.buffer);

	str_replace(';', 0, Vals[attrpos]);
	pAttrPos = Vals[attrpos];
	for (i = 0;i < 6;i++)
	{
		((clsTemplateSource*) TargetStruct)->AttributeMod[i] = atoi(pAttrPos);
		pAttrPos += strlen(pAttrPos) + 1;
	}
	
	if (bnf::bnfparse(Vals[crscriptpos], &(((clsTemplateSource*) TargetStruct)->CRScript)) ||
		bnf::bnfparse(Vals[scriptpos], &(((clsTemplateSource*) TargetStruct)->Script)))
	{
		printf("Error in Template Script %s\n", Vals[namepos]);
		quitprog();
	}
}

void TemplateSourceExit()
{
	int i;
	for (i = 0;i < Source.TemplateSourceCount;i++)
	{
		freel(Source.TemplateSource[i].CRScript);
		freel(Source.TemplateSource[i].Script);
	}
	delete[] Source.TemplateSource;
}
